DataStores (LucidLink Connect)
DataStores are S3 connection configurations for cloud storage. A DataStore holds the bucket name, access key, and secret key for a single S3 bucket. Files from the bucket can then be surfaced inside a filespace as ExternalEntries.
/api/v1/filespaces/{filespaceId}/external/data-stores
List all data stores
Retrieves a list of all data stores in the filespace.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Filter data stores by name. |
|
| Required. |
name
Type
stringDescription
Filter data stores by name.
filespaceId
Type
stringDescription
Required.
Responses
Status | Description |
|---|---|
| Data stores have been successfully listed. |
| Invalid or missing credentials. |
| 1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured. |
200
Description
Data stores have been successfully listed.
401
Description
Invalid or missing credentials.
403
Description
1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured.
200 response
[{"id": "bXktZGF0YS1zdG9yZQ","name": "my-data-store","kind": "S3DataStore","s3StorageParams": {"accessKey": "AKIAIOSFODNN7EXAMPLE","bucketName": "my-bucket","region": "us-east-1","endpoint": "https://s3.amazonaws.com","useVirtualAddressing": true,"urlExpirationMinutes": 10080}}]
401 response
{"error": {"message": "Invalid or expired token"}}
/api/v1/filespaces/{filespaceId}/external/data-stores
Create a data store
Creates a data store. For S3DataStore, provide s3StorageParams with credentials for accessing cloud object storage. For HttpLinkDataStore, no additional parameters are required.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
filespaceId
Type
stringDescription
Required.
Request body
Field | Type | Description |
|---|---|---|
|
| Required. Name of the data store |
|
| Required. The specific kind of data store |
|
| S3 cloud storage configuration parameters for this data store. Required when kind is "S3DataStore". |
name
Type
stringDescription
Required. Name of the data store
kind
Type
DataStoreKindDescription
Required. The specific kind of data store
s3StorageParams
Type
S3StorageParamsDtoDescription
S3 cloud storage configuration parameters for this data store. Required when kind is "S3DataStore".
Responses
Status | Description |
|---|---|
| Data store has been successfully created. |
| 1. Data store already exists. 2. Maximum number of data stores reached. 3. s3StorageParams.bucketName is invalid. 4. s3StorageParams.region is invalid. 5. This data store type is not supported. |
| Invalid or missing credentials. |
| 1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured. |
201
Description
Data store has been successfully created.
400
Description
1. Data store already exists. 2. Maximum number of data stores reached. 3. s3StorageParams.bucketName is invalid. 4. s3StorageParams.region is invalid. 5. This data store type is not supported.
401
Description
Invalid or missing credentials.
403
Description
1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured.
201 response
{"id": "bXktZGF0YS1zdG9yZQ","name": "my-data-store","kind": "S3DataStore","s3StorageParams": {"accessKey": "AKIAIOSFODNN7EXAMPLE","bucketName": "my-bucket","region": "us-east-1","endpoint": "https://s3.amazonaws.com","useVirtualAddressing": true,"urlExpirationMinutes": 10080}}
400 response
{"error": {"message": "Data store already exists"}}
401 response
{"error": {"message": "Invalid or expired token"}}
/api/v1/filespaces/{filespaceId}/external/data-stores/{dataStoreId}
Get information about a data store
Retrieves information about a specific data store by its ID.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
|
| Required. |
dataStoreId
Type
stringDescription
Required.
filespaceId
Type
stringDescription
Required.
Responses
Status | Description |
|---|---|
| Data store information has been successfully fetched. |
| Data store ID is invalid. |
| Invalid or missing credentials. |
| 1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured. |
| Data store not found. |
200
Description
Data store information has been successfully fetched.
400
Description
Data store ID is invalid.
401
Description
Invalid or missing credentials.
403
Description
1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured.
404
Description
Data store not found.
200 response
{"id": "bXktZGF0YS1zdG9yZQ","name": "my-data-store","kind": "S3DataStore","s3StorageParams": {"accessKey": "AKIAIOSFODNN7EXAMPLE","bucketName": "my-bucket","region": "us-east-1","endpoint": "https://s3.amazonaws.com","useVirtualAddressing": true,"urlExpirationMinutes": 10080}}
400 response
{"error": {"message": "Data store ID is invalid"}}
401 response
{"error": {"message": "Invalid or expired token"}}
404 response
{"error": {"message": "Data store not found"}}
/api/v1/filespaces/{filespaceId}/external/data-stores/{dataStoreId}
Update data store credentials
Updates the credentials (access key and secret key) for an existing data store.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
|
| Required. |
dataStoreId
Type
stringDescription
Required.
filespaceId
Type
stringDescription
Required.
Request body
Field | Type | Description |
|---|---|---|
|
| Required. Updated S3 storage credentials (access key and secret key) |
s3StorageParams
Type
S3StorageParamsUpdateDtoDescription
Required. Updated S3 storage credentials (access key and secret key)
Responses
Status | Description |
|---|---|
| Data store has been successfully updated. |
| 1. Data store ID is invalid. 2. Cannot update data store with invalid credentials. 3. This data store type is not supported. |
| Invalid or missing credentials. |
| 1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured. |
| Data store not found. |
200
Description
Data store has been successfully updated.
400
Description
1. Data store ID is invalid. 2. Cannot update data store with invalid credentials. 3. This data store type is not supported.
401
Description
Invalid or missing credentials.
403
Description
1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured.
404
Description
Data store not found.
200 response
{"id": "bXktZGF0YS1zdG9yZQ","name": "my-data-store","kind": "S3DataStore","s3StorageParams": {"accessKey": "AKIAIOSFODNN7EXAMPLE","bucketName": "my-bucket","region": "us-east-1","endpoint": "https://s3.amazonaws.com","useVirtualAddressing": true,"urlExpirationMinutes": 10080}}
401 response
{"error": {"message": "Invalid or expired token"}}
404 response
{"error": {"message": "Data store not found"}}
/api/v1/filespaces/{filespaceId}/external/data-stores/{dataStoreId}
Delete a data store
Deletes a data store by its ID.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
|
| Required. |
dataStoreId
Type
stringDescription
Required.
filespaceId
Type
stringDescription
Required.
Responses
Status | Description |
|---|---|
| Data store has been successfully deleted. |
| 1. Data store ID is invalid. 2. Cannot delete data store with linked files. |
| Invalid or missing credentials. |
| 1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured. |
| Data store not found. |
200
Description
Data store has been successfully deleted.
400
Description
1. Data store ID is invalid. 2. Cannot delete data store with linked files.
401
Description
Invalid or missing credentials.
403
Description
1. Data stores are not supported on this filespace version. 2. Data stores cannot be managed when external files feature is not configured.
404
Description
Data store not found.
401 response
{"error": {"message": "Invalid or expired token"}}
404 response
{"error": {"message": "Data store not found"}}